﻿using System.Diagnostics;
using System.Threading;
using System.Xml;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using Clio.Utilities;
using GourmetGuy.Settings;
using System;
using System.Collections.Generic;
using System.IO;
using System.Configuration;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;
using TreeSharp;

using Action = TreeSharp.Action;

namespace GourmetGuy
{
    public class GourmetGuy : IBotPlugin
    {
        #region Initialization Information
        public string Author { get { return " kagamihiiragi17"; } }
        public string Description { get { return "Keeps your food buff active at all times"; } }
        public Version Version { get { return new Version(1, 2, 2); } }
        public string Name { get { return "GourmetGuy"; } }

        public bool WantButton
        {
            get { return true; }
        }
        public string ButtonText
        {
            get { return "GourmetGuy"; }
        }
        public void OnButtonPress()
        {
            if (_form == null || _form.IsDisposed || _form.Disposing)
                _form = new GourmetGuy_Form();

            _form.ShowDialog();
        }
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion

        private GourmetGuy_Form _form;
        public static GourmetGuySettings settings = GourmetGuySettings.instance;
        public static bool DoubleCastPrevention = false;

        #region Init
        public void OnInitialize()
        {

        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {
            Logging.Write("[GourmetGuy] Enabled");
        }
        public void OnDisabled()
        {
            Logging.Write("[GourmetGuy] Disabled");
        }
        #endregion

        public static void Use(string itemname)
        {
            foreach (BagSlot a in InventoryManager.FilledSlots)
            {
                if (a.Name == settings.FoodName)
                {
                    a.UseItem();
                    ff14bot.Helpers.Logging.Write("[GourmetGuy] Using Item: " + a.Name);
                    return;
                }
            }
        }

        #region Pulse
        public void OnPulse()
        {
            if (DoubleCastPrevention && Core.Player.HasAura("Well Fed"))
            {
                DoubleCastPrevention = false;
            }

            if (!Core.Player.HasAura("Well Fed") && settings.FoodName != null && !DoubleCastPrevention && !Core.Player.InCombat && !Core.Player.IsMounted && Core.Player.IsValid)
            {
                Use(settings.FoodName);
                DoubleCastPrevention = true;
            }
        }
        #endregion
    }
}